import type { BaseContract, BigNumber, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent } from "./common";
export interface IL2AssetRouterInterface extends utils.Interface {
    functions: {
        "l1TokenAddress(address)": FunctionFragment;
        "withdraw(bytes32,bytes)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "l1TokenAddress" | "withdraw"): FunctionFragment;
    encodeFunctionData(functionFragment: "l1TokenAddress", values: [string]): string;
    encodeFunctionData(functionFragment: "withdraw", values: [BytesLike, BytesLike]): string;
    decodeFunctionResult(functionFragment: "l1TokenAddress", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdraw", data: BytesLike): Result;
    events: {};
}
export interface IL2AssetRouter extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: IL2AssetRouterInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        l1TokenAddress(_l2TokenAddress: string, overrides?: CallOverrides): Promise<[string]>;
        withdraw(_assetId: BytesLike, _assetData: BytesLike, overrides?: Overrides & {
            from?: string;
        }): Promise<ContractTransaction>;
    };
    l1TokenAddress(_l2TokenAddress: string, overrides?: CallOverrides): Promise<string>;
    withdraw(_assetId: BytesLike, _assetData: BytesLike, overrides?: Overrides & {
        from?: string;
    }): Promise<ContractTransaction>;
    callStatic: {
        l1TokenAddress(_l2TokenAddress: string, overrides?: CallOverrides): Promise<string>;
        withdraw(_assetId: BytesLike, _assetData: BytesLike, overrides?: CallOverrides): Promise<string>;
    };
    filters: {};
    estimateGas: {
        l1TokenAddress(_l2TokenAddress: string, overrides?: CallOverrides): Promise<BigNumber>;
        withdraw(_assetId: BytesLike, _assetData: BytesLike, overrides?: Overrides & {
            from?: string;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        l1TokenAddress(_l2TokenAddress: string, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        withdraw(_assetId: BytesLike, _assetData: BytesLike, overrides?: Overrides & {
            from?: string;
        }): Promise<PopulatedTransaction>;
    };
}
